#!/usr/bin/perl -wT
#----------------------------------------------------------------------
#
# copyright (C) Decaux Nicolas Aka 'GawiNDX'
# contributor: Nicolas Decaux <decauxnico@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#----------------------------------------------------------------------

package esmith::FormMagick::Panel::Mozus;

use strict;
use warnings;
use esmith::ConfigDB;
use esmith::FormMagick;
use esmith::cgi;
use File::Path;
use CGI::Carp qw(fatalsToBrowser);


our @ISA = qw(esmith::FormMagick Exporter);

our @EXPORT = qw();

our $VERSION = sprintf '%d.%03d', q$Revision: 1.1 $ =~ /: (\d+).(\d+)/;

our $mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";

sub Show_Form
{
	my $self = shift;
    my $q = $self->{cgi};
	
	#On Definit les arrays necessaires
	my %enabled_disabled_labels = 	( 	'enabled' 		=> $self->localise('ENABLED'),
										'disabled' 		=> $self->localise('DISABLED'));
	my %access_labels = 			( 	'public' 		=> $self->localise('PUBLIC'),
										'private' 		=> $self->localise('PRIVATE'));
	my %yes_no_labels = 			( 	'enabled' 		=> $self->localise('YES'),
										'disabled' 		=> $self->localise('NO'));
	my %platform_labels=			(	'win32'			=> $self->localise('PFORM_WINDOWS'),
										'mac'			=> $self->localise('PFORM_MAC'),
										'linux-i686'	=> $self->localise('PFORM_LIN32'),
										'linux-x86_64'	=> $self->localise('PFORM_LIN64'));
	my @key_locale = split('@', $self->localise('LOCALE_DISPO'));
	my $VersionDispo = &get_version_dispo();
	my $array_used_locale = &get_used_locale();
	my $hash_locale2sync = &get_locale2sync($self->localise('LOCALE_NAME'),$self->localise('LOCALE_DISPO'));
	my $array_locale = &get_platform();
	my $array_version = &get_version();
	print "<tr><td colspan=2><table>\n";
	print $q->Tr(
		$q->td($q->h2($self->localise('MOZUS_STATUS_DESCRIPTION1')))),
	$q->Tr(
        $q->td($q->h3($self->localise('MOZUS_STATUS_DESCRIPTION2')))),
	$q->Tr(
		$q->td($self->localise('MOZUS_SIZE_MIRROR'))),
	$q->Tr(),
	$q->Tr($q->td(
			$q->table({width => "100%", -class => "sme-noborders"},$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('MOZUS_STATUS'),"sme-noborders-label"),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'Mozus_status', -values => [ 'enabled','disabled' ],
									-default => &get_moz_status(), -labels => \%enabled_disabled_labels), "sme-noborders-content")),
				)))),
	$q->Tr(
		$q->td($self->localise('MOZUS_ACCESS_DESCRIPTION'))),
	$q->Tr(	$q->td(
		$q->table({width => "100%", -class => "sme-noborders"},$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('MOZUS_ACCESS'),"sme-noborders-label"),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'Mozus_access', -values => [ 'public','private' ],
									-default => &get_moz_access(), -labels => \%access_labels), "sme-noborders-content")),
				)))),
	$q->Tr(
		$q->td($self->localise('MOZ_APPTB_STATUS'))),
	$q->Tr($q->td(
			$q->table({width => "100%", -class => "sme-noborders"},$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('MOZ_TBIRD_STATUS'),"sme-noborders-label"),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'Thunderbird_status', -values => [ 'enabled','disabled' ],
									-default => &get_tbird_status(), -labels => \%enabled_disabled_labels), "sme-noborders-content")),
				),$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('MOZ_FFOX_STATUS'),"sme-noborders-label"),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'Firefox_status', -values => [ 'enabled','disabled' ],
									-default => &get_ffox_status(), -labels => \%enabled_disabled_labels), "sme-noborders-content")),
				)))),
	$q->Tr(
		$q->td($self->localise('MOZ_MAJOR_DESCRIPTION'))),
	$q->Tr($q->td(
			$q->table({width => "100%", -class => "sme-noborders"},$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('MOZ_MAJOR'),"sme-noborders-label"),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'Major_update', -values => [ 'enabled','disabled' ],
									-default => &get_major_enabled(), -labels => \%enabled_disabled_labels), "sme-noborders-content")),
				)))),
	$q->Tr(
	$q->td($self->localise('MOZ_LOCALE_DISPO_DESCRIPTION'))),
	$q->Tr($q->td(
			$q->table({width => "100%", -class => "sme-noborders"},$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('MOZ_LOCALE_DISPO'),"sme-noborders-label"),
				esmith::cgi::genCell (($q,$q->scrolling_list (-name => 'localedispo', -values => [ @key_locale ], -multiple => 'true', -size => 10, 
									-default => [ @$array_used_locale ], -labels => &get_locale_dispo($self->localise('LOCALE_NAME'),$self->localise('LOCALE_DISPO'))),
									"sme-noborders-content")),
				)))),
	$q->Tr(
    $q->td($self->localise('MOZ_LOCALE_DEFAULT_DESCRIPTION'))),
	$q->Tr($q->td(
			$q->table({width => "100%", -class => "sme-noborders"},$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('MOZ_LOCALE_DEFAULT'),"sme-noborders-label"),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'localedefault', -values => [ (keys %$hash_locale2sync ) ],
									-default => &get_default_lang(), -labels => \%$hash_locale2sync ), "sme-noborders-content")),
				)))),
	$q->Tr(
    $q->td($self->localise('MOZ_PLATFORM_DESCRIPTION'))),
	$q->Tr($q->td(
			$q->table({width => "100%", -class => "sme-noborders"},$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('MOZ_PLATFORM'),"sme-noborders-label"),
				esmith::cgi::genCell (($q,$q->scrolling_list (-name => 'platform', -values => [ (sort keys %platform_labels) ], -multiple => 1, -size =>4,
									-default => [ @$array_locale ], -labels => \%platform_labels), "sme-noborders-content")),
				)))),
	$q->Tr(
    $q->td($self->localise('MOZ_VERSION_DESCRIPTION'))),
	$q->Tr($q->td(
			$q->table({width => "100%", -class => "sme-noborders"},$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('MOZ_VERSION'),"sme-noborders-label"),
				esmith::cgi::genCell (($q,$q->scrolling_list (-name => 'list_version', -values => [ @$VersionDispo ], -multiple => 1, -size => 4,
									-default =>  [ @$array_version ], "sme-noborders-content")),
				))))),
	$q->Tr(
    $q->td($self->localise('MOZ_OBSOLETE_DESCRIPTION'))),
	$q->Tr($q->td(
			$q->table({width => "100%", -class => "sme-noborders"},$q->Tr({-class => "sme-noborders-label"},    
				esmith::cgi::genCell ($q, '',"sme-noborders-label"),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'keep_obsolete', -values => [ 'enabled','disabled' ],
									-default => 'enabled', -labels => \%yes_no_labels), "sme-noborders-content")),
				))));
	print "</table></td></tr>\n";
	return '';
}

sub get_size_folder
{
	my $fm = @_;
	my $description = "";
	my $dir = "/opt/mozilla-updates/mirror/";
	my $sizes = `du -sk /opt/mozilla-updates/mirror/`;
	my $size = 0;
	for(split /[\r\n]+/,$sizes) # split on one or more newline characters
	{ 
		my($number,$file) = split /\t/,$_,2; # split on tab ($file not used here)
		$size += $number; 
	}
	$size = sprintf("%.02f",$size / 1024 );
	$description = "Actuellement, l'espace utilise sur votre Serveur par les mises a jour est de $size MB";
    return ( var => $description);
}

sub get_moz_status
{
	$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
    return $mozus_db->get_prop("Mozus", "status");
}

sub get_moz_access
{
	$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
	my $mozaccess = $mozus_db->get_prop("Mozus","access");
	return $mozaccess;	
}

sub get_tbird_status
{
	$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
    return $mozus_db->get_prop("Mozus", "thunderbird");
}

sub get_ffox_status
{
	$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
    return $mozus_db->get_prop("Mozus", "firefox");
}

sub get_interval
{
    return $mozus_db->get_prop("Mozus", "version");
}

sub get_locale_dispo
{

	use List::Util qw(first);
	   	my ($loc_name , $loc_dispo) = @_;
       my @locale_name = split("@",$loc_name);
	   my @locale_dispo = split("@",$loc_dispo);
	   my @locale_disp =();

	   foreach my $elements (@locale_dispo) {
		my $index = first { $locale_dispo[$_] eq $elements } 0 .. $#locale_dispo;
		push @locale_disp, $elements;
		push @locale_disp, $locale_name[$index];
    	}

	my %options = @locale_disp;
#    return { @locale_disp };
	return \%options ;

}

sub get_used_locale
{
	$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
	my $used_locale = $mozus_db->get_prop("Mozus","locale");
	my @value_locale = split("@",$used_locale);
	
	return \@value_locale;
}

sub get_locale2sync
{
use List::Util qw(first);
	$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
	my ($loc_name , $loc_dispo) = @_;
	my $fm = @_;
	my $self = shift;
    my @locale_name = split("@",$loc_name);
	my @locale_dispo = split("@",$loc_dispo);
	my @locale_disp ;

	foreach my $elements (@locale_dispo) {
		my $index = first { $locale_dispo[$_] eq $elements } 0 .. $#locale_dispo;
		push @locale_disp, $elements;
		push @locale_disp, $locale_name[$index];
    }
	  
	my $locale_used = $mozus_db->get_prop("Mozus","locale");
	my @locale_used = split("@",$locale_used);
	my @locale_list =();
	my %locale_list = @locale_disp;
	foreach my $elements (@locale_used){
	    my $index = first { $locale_disp[$_] eq $elements } 0 .. $#locale_disp;
		push @locale_list, $elements ;
		push @locale_list, $locale_list{$elements};		
		}
	my %options = @locale_list;
	return \%options;
}

sub get_default_lang
{
	$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
	return $mozus_db->get_prop("Mozus","DefaultLang");
}

sub get_major_enabled
{
	my $majorenable = $mozus_db->get_prop("Mozus","enablemajor");
	return $majorenable;	
}

sub get_version
{
	$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
	my $version = $mozus_db->get_prop("Mozus","version");
	my @version = split('@',$version);
	return \@version;
}

sub get_version_dispo
{
	$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
	my $version = $mozus_db->get_prop("Mozus","VersionDispo");
	my @version = split('@',$version);
	return \@version;
}

sub get_platform
{
	$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
	my $platform = $mozus_db->get_prop("Mozus","platform");
	my @platform = split("@",$platform);
	return \@platform;
}

sub change_settings
{
    my $fm = shift;
    my $q = $fm->{'cgi'};
	$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
    $mozus_db->set_prop('Mozus', 'status', $q->param("Mozus_status"));
	$mozus_db->set_prop('Mozus', 'access', $q->param("Mozus_access"));
    $mozus_db->set_prop('Mozus', 'thunderbird', $q->param("Thunderbird_status"));
    $mozus_db->set_prop('Mozus', 'firefox', $q->param("Firefox_status"));
	$mozus_db->set_prop('Mozus', 'enablemajor', $q->param("Major_update"));
	my @locale = $q->param("localedispo");
	my $localelangs = join('@',@locale);
	$mozus_db->set_prop('Mozus','locale',$localelangs);
	my $DefLang = $q->param("localedefault");
	my $inlocale = "false";
	foreach my $lang (@locale){
		if ( $lang eq $DefLang ) {
			$inlocale = "true";
		}
	}
	if ( $inlocale ne "true"){
		$DefLang = $locale[0];
	}
	$mozus_db->set_prop('Mozus', 'DefaultLang', $DefLang);
	my @platformsave = $q->param("platform");
	my $platformsave = join('@',@platformsave);
	$mozus_db->set_prop('Mozus','platform',$platformsave);
	my @listversion = $q->param("list_version");
	my $listversion = join('@',@listversion);
	$mozus_db->set_prop('Mozus','version',$listversion);
	my $mirrordir = $mozus_db->get_prop('Mozus','mirrordir') || "/opt/mozilla-updates/mirror";
	my @prod;
	my $obso_dir;
	my @rmdir_array;
	my @keepdir_array;
	if ( $q->param('keep_obsolete') eq 'disabled' ) {
		my $status= system ("/opt/mozilla-updates/mozmirrorupdates","delete-obsolete");
	}
	
    unless ( ( system ("/sbin/e-smith/expand-template", "/opt/mozilla-updates/mirror/updates") == 0 ) and ( system ("/sbin/e-smith/expand-template", "/opt/mozilla-updates/SOGo-plugins/updates.php") == 0 ) )
    {
        $fm->error('ERROR_UPDATING');
		$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
        return undef;
    }

    $fm->success('SUCCESS');
	$mozus_db = esmith::ConfigDB->open('Mozus') or die "Couldn't open ConfigDB\n";
}