#!/usr/bin/perl -wT
#----------------------------------------------------------------------
#
# copyright (C) Decaux Nicolas Aka 'GawiNDX'
# contributor: Nicolas Decaux <decauxnico@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#----------------------------------------------------------------------
package esmith::FormMagick::Panel::Mozus_schedule;

use strict;
use warnings;
use esmith::ConfigDB;
use esmith::FormMagick;
use esmith::cgi;
use CGI::Carp qw(fatalsToBrowser);

our @ISA = qw(esmith::FormMagick Exporter);

our @EXPORT = qw();

our $VERSION = sprintf '%d.%03d', q$Revision: 1.1 $ =~ /: (\d+).(\d+)/;

our $mozus_db = esmith::ConfigDB->open('Mozus')or die "Cannot open Mozus DB\n";

sub Show_Form
{
	my $self = shift;
    my $q = $self->{cgi};
	
	my $schedule_mode = $mozus_db->get_prop('Scheduler', 'Mode') || 'Monthly';
	my $moz_daily = $mozus_db->get_prop('Scheduler', 'Daily') || '0,0';
	my $moz_weekly =$mozus_db->get_prop('Scheduler', 'Weekly') || '0,0,0';
	my $moz_dweekly = $mozus_db->get_prop('Scheduler', 'DWeekly') || '0,0,0';
	my $moz_monthly = $mozus_db->get_prop('Scheduler', 'Monthly') || '1,0,0';
	my @Daily = split(',',$moz_daily);
	my @Weekly = split(',',$moz_weekly);
	my @DWeekly = split(',',$moz_dweekly);
	my @Monthly = split(',',$moz_monthly);

# Definition des jours
	my %Day_labels = ( 	'0' => $self->localise('DIMANCHE'),
						'1' => $self->localise('LUNDI'),
						'2' => $self->localise('MARDI'),
						'3' => $self->localise('MERCREDI'),
						'4' => $self->localise('JEUDI'),
						'5' => $self->localise('VENDREDI'),
						'6' => $self->localise('SAMEDI'));
#Definition des jours du mois
	my %month_day_labels =( '0','0','1','1','2','2','3','3','4','4','5','5','6','6','7','7','8','8','9','9','10','10','11','11',
						'12','12','13','13','14','14','15','15','16','16','17','17','18','18','19','19','20','20','21','21','22','22','23','23',
						'24','24','25','25','26','26','27','27','28','28','29','29','30','30','31','31');
# Definition des Heures
	my %hours_labels =( '0','0','1','1','2','2','3','3','4','4','5','5','6','6','7','7','8','8','9','9','10','10','11','11',
						'12','12','13','13','14','14','15','15','16','16','17','17','18','18','19','19','20','20','21','21','22','22','23','23');
	my %minutes_labels = ('0','0','15','15','30','30','45','45');

# create radio buttons in the same group
    my ($rbNone, $rbDaily, $rbWeekly, $rbDoubleWeekly, $rbMonthly) = 
        $q->radio_group(-name => 'RB_Schedule', 
            -values => ['None', 'Daily','Weekly','DoubleWeekly','Monthly'],
            -default => $schedule_mode,
            -linebreak => 'true', 
            -labels => { None => '', Daily => '', Weekly => '', DoubleWeekly => '', Monthly => ''});

#Create Select for hours
	print "<tr><td colspan=2><table>\n";
	print $q->Tr(
        $q->td({-class => "sme-radiobutton"}, $rbNone),
		$q->td($q->h3($self->localise('MOZ_SCHEDULE_NONE')))),
	$q->Tr(
		$q->td({-class => "sme-radiobutton"}, "&nbsp;"),
        $q->td($self->localise('MOZ_SCHEDULE_NONE_DESC'))),
	$q->Tr(
		$q->td({-class => "sme-radiobutton"}, $rbDaily),
        $q->td($q->h3($self->localise('MOZ_SCHEDULE_DAILY')))),
	$q->Tr(
		$q->td({-class => "sme-radiobutton"}, "&nbsp;"),
        $q->td($self->localise('MOZ_SCHEDULE_DAILY_DESC'))),
	$q->Tr($q->td(
		$q->td(
			$q->table({-class => "sme-noborders"},$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('HOUR_INFO')),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'hours_daily', -values => [ 0..23 ],
									-default => $Daily[0], -labels => \%hours_labels), "sme-noborders-content")),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'minutes_daily', -values => [ 0,15,30,45 ],
									-default => $Daily[1], -labels => \%minutes_labels), "sme-noborders-content")),
				))))),
	$q->Tr(
		$q->td({-class => "sme-radiobutton"}, $rbWeekly),
        $q->td($q->h3($self->localise('MOZ_SCHEDULE_WEEKLY')))),
	$q->Tr(
	$q->td({-class => "sme-radiobutton"}, "&nbsp;"),
        $q->td($self->localise('MOZ_SCHEDULE_WEEKLY_DESC'))),
	$q->Tr($q->td(
		$q->td(
			$q->table({-class => "sme-noborders"},$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('WEEKLY_DAY_INFO')),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'day_weekly', -values => [ 0..6 ],
									-default => $Weekly[0], -labels => \%Day_labels), "sme-noborders-content")),
				),$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('HOUR_INFO')),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'hours_weekly', -values => [ 0..23 ],
									-default => $Weekly[1], -labels => \%hours_labels), "sme-noborders-content")),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'minutes_weekly', -values => [ 0,15,30,45 ],
									-default => $Weekly[2], -labels => \%minutes_labels), "sme-noborders-content")),
				))))),
	$q->Tr(	
		$q->td({-class => "sme-radiobutton"}, $rbDoubleWeekly),
        $q->td($q->h3($self->localise('MOZ_SCHEDULE_DOUBLE_WEEKLY')))),
	$q->Tr(
		$q->td({-class => "sme-radiobutton"}, "&nbsp;"),
        $q->td($self->localise('MOZ_SCHEDULE_DOUBLE_WEEKLY_DESC'))),
	$q->Tr($q->td(
		$q->td(
			$q->table({-class => "sme-noborders"},$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('WEEKLY_DAY_INFO')),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'day_dweekly', -values => [ 0..6 ],
									-default => $DWeekly[0], -labels => \%Day_labels), "sme-noborders-content")),
				),$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('HOUR_INFO')),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'hours_dweekly', -values => [ 0..23 ],
									-default => $DWeekly[1], -labels => \%hours_labels), "sme-noborders-content")),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'minutes_dweekly', -values => [ 0,15,30,45 ],
									-default => $DWeekly[2], -labels => \%minutes_labels), "sme-noborders-content")),
				))))),
	$q->Tr(
	$q->td({-class => "sme-radiobutton"}, $rbMonthly),
        $q->td($q->h3($self->localise('MOZ_SCHEDULE_MONTHLY')))),
	$q->Tr(
		$q->td({-class => "sme-radiobutton"}, "&nbsp;"),
        $q->td($self->localise('MOZ_SCHEDULE_MONTHLY_DESC'))),
	$q->Tr($q->td(
		$q->td(
			$q->table({-class => "sme-noborders"},$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('MONTHLY_INFO')),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'day_monthly', -values => [ 1..31 ],
									-default => $Monthly[0], -labels => \%month_day_labels), "sme-noborders-content")),
				),$q->Tr(
				esmith::cgi::genCell ($q, $self->localise('HOUR_INFO')),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'hours_monthly', -values => [ 0..23 ],
									-default => $Monthly[1], -labels => \%hours_labels), "sme-noborders-content")),
				esmith::cgi::genCell (($q,$q->popup_menu (-name => 'minutes_monthly', -values => [ 0,15,30,45 ],
									-default => $Monthly[2], -labels => \%minutes_labels), "sme-noborders-content")),
				))))),"\n";
	print "</table></td></tr>\n";
	return '';
}

sub get_boot_mode
{
	my $Boot_sync = $mozus_db->get_prop('Scheduler', 'Boot_Sync') || 'enabled';
}
sub Save_Param
{
	my $self = shift;
    my $q = $self->{cgi};
	
	my $Boot_Sync = $q->param('boot_sync');
	my $schedule_mode = $q->param('RB_Schedule');
	my $Daily = $q->param('hours_daily') .",".$q->param('minutes_daily');
	my $Weekly = $q->param('day_weekly') .",".$q->param('hours_weekly').",".$q->param('minutes_weekly');
	my $DWeekly = $q->param('day_dweekly') .",".$q->param('hours_dweekly').",".$q->param('minutes_dweekly');
	my $Monthly = $q->param('day_monthly') .",".$q->param('hours_monthly').",".$q->param('minutes_monthly');
	$mozus_db->set_prop('Scheduler', 'Mode',"$schedule_mode");
	$mozus_db->set_prop('Scheduler', 'Daily',"$Daily");
	$mozus_db->set_prop('Scheduler', 'Weekly',"$Weekly");
	$mozus_db->set_prop('Scheduler', 'DWeekly',"$DWeekly");
	$mozus_db->set_prop('Scheduler', 'Monthly',"$Monthly");
	$mozus_db->set_prop('Scheduler', 'Boot_Sync',"$Boot_Sync");
	system("/sbin/e-smith/expand-template /etc/crontab");
	return $self->success('SUCCESS');

}
